#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QtMultimedia/qaudio.h>
#include <QSound>
#include <QTime>
#include <QWidget>
#include <QObject>
#include <QIODevice>
#include <QtMultimedia/QAudioInput>
#include <audioinfo.h>
#include <preferences.h>

#include <QSensor>
#include <QAccelerometer>
#include <QOrientationSensor>
#include <QFileDialog>

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT
    QString alarmTime;
    QString recordTime;
    int alarm_state;
    float time_from_start;
    QSound *soundObject;
//    QSensor *sensor;
    QtMobility::QAccelerometer sensorAcc;
    QtMobility::QOrientationSensor sensorOri;

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();
    void initializeAlarm();
    void setAlarmTime();
    void unsetAlarmTime();
    void browseFile();

private:
    Ui::MainWindow *ui;
    QAudioDeviceInfo m_device;
    AudioInfo *m_audioInfo;
    QAudioFormat m_format;
    QAudioInput *m_audioInput;
    QIODevice *m_input;
    bool m_pullMode;
    QByteArray m_buffer;
    qreal prevLevel;
    qreal maxLevel;
    preferences conf;
    bool readLevel;
    qreal accX;
    qreal accY;
    qreal accZ;
    int ori;
    QString soundPath;
    void readInitialOri();

public slots:
    void playAlarm();
    void timeControl();
    void startClock();
    void setAlarm();
    void updateLevel();
    void setLevelAverage();
    void generalInitialization();
    void applySettings();
    void resetSettings();
    void readSensorAcc();
    void readSensorOri();
};

#endif // MAINWINDOW_H
